_grk_cparameters Struct Reference

Compress parameters. More...

`#include <grok.h>`

## Public Attributes

bool | tile_size_on
| size of tile: tile_size_on = false (not in argument) or = true (in argument)
uint32_t | tx0
| XTOsiz.
uint32_t | ty0
| YTOsiz.
uint32_t | t_width
| XTsiz.
uint32_t | t_height
| YTsiz.
uint16_t | numlayers
| number of layers
bool | allocationByRateDistoration
| rate control allocation by rate/distortion curve
double | layer_rate [GRK_MAX_LAYERS]
| layers rates expressed as compression ratios.
bool | allocationByQuality
| rate control allocation by fixed_PSNR quality
double | layer_distortion [GRK_MAX_LAYERS]
| layer PSNR values
char * | comment [GRK_NUM_COMMENTS_SUPPORTED]
uint16_t | comment_len [GRK_NUM_COMMENTS_SUPPORTED]
bool | is_binary_comment [GRK_NUM_COMMENTS_SUPPORTED]
size_t | num_comments
uint8_t | csty
| csty : coding style
uint8_t | numgbits
GRK_PROG_ORDER | prog_order
| progression order (default is LRCP)
grk_progression | progression [GRK_J2K_MAXRLVLS]
| progressions
uint32_t | numpocs
| number of progression order changes (POCs), default to 0
uint8_t | numresolution
| number of resolutions
uint32_t | cblockw_init
| initial code block width (default to 64)
uint32_t | cblockh_init
| initial code block height (default to 64)
uint8_t | cblk_sty
| code block style
bool | irreversible
| 1 : use the irreversible DWT 9-7, 0 : use lossless compression (default)
int32_t | roi_compno
| region of interest: affected component in [0..3]; -1 indicates no ROI
uint32_t | roi_shift
| region of interest: upshift value
uint32_t | res_spec
uint32_t | prcw_init [GRK_J2K_MAXRLVLS]
| initial precinct width
uint32_t | prch_init [GRK_J2K_MAXRLVLS]
| initial precinct height
char | infile [GRK_PATH_LEN]
| input file name
char | outfile [GRK_PATH_LEN]
| output file name
uint32_t | image_offset_x0
| subimage compressing: origin image offset in x direction
uint32_t | image_offset_y0
| subimage compressing: origin image offset in y direction
uint8_t | subsampling_dx
| subsampling value for dx
uint8_t | subsampling_dy
| subsampling value for dy
GRK_SUPPORTED_FILE_FMT | decod_format
| input file format
GRK_SUPPORTED_FILE_FMT | cod_format
| output file format
grk_raw_cparameters | raw_cp
uint32_t | max_comp_size
| Maximum size (in bytes) for each component.
bool | enableTilePartGeneration
| Tile part generation.
uint8_t | newTilePartProgressionDivider
| new tile part progression divider
uint8_t | mct
| MCT (multiple component transform)
void * | mct_data
| Naive implementation of MCT restricted to a single reversible array based compressing without offset concerning all the components.
uint64_t | max_cs_size
| Maximum size (in bytes) for the whole code stream.
uint16_t | rsiz
| RSIZ value To be used to combine GRK_PROFILE_*, GRK_EXTENSION_* and (sub)levels values.
uint16_t | framerate
bool | write_capture_resolution_from_file
double | capture_resolution_from_file [2]
bool | write_capture_resolution
double | capture_resolution [2]
bool | write_display_resolution
double | display_resolution [2]
bool | apply_icc_
GRK_RATE_CONTROL_ALGORITHM | rateControlAlgorithm
uint32_t | numThreads
int32_t | deviceId
uint32_t | duration
uint32_t | kernelBuildOptions
uint32_t | repeats
bool | writePLT
bool | writeTLM
bool | verbose

## Detailed Description

Compress parameters.

## Member Data Documentation

## allocationByQuality

bool _grk_cparameters::allocationByQuality

rate control allocation by fixed_PSNR quality

## allocationByRateDistoration

bool _grk_cparameters::allocationByRateDistoration

rate control allocation by rate/distortion curve

## apply_icc_

bool _grk_cparameters::apply_icc_

## capture_resolution

double _grk_cparameters::capture_resolution[2]

## capture_resolution_from_file

double _grk_cparameters::capture_resolution_from_file[2]

## cblk_sty

uint8_t _grk_cparameters::cblk_sty

code block style

## cblockh_init

uint32_t _grk_cparameters::cblockh_init

initial code block height (default to 64)

## cblockw_init

uint32_t _grk_cparameters::cblockw_init

initial code block width (default to 64)

## cod_format

GRK_SUPPORTED_FILE_FMT _grk_cparameters::cod_format

output file format

## comment

char* _grk_cparameters::comment[GRK_NUM_COMMENTS_SUPPORTED]

## comment_len

uint16_t _grk_cparameters::comment_len[GRK_NUM_COMMENTS_SUPPORTED]

## csty

uint8_t _grk_cparameters::csty

csty : coding style

## decod_format

GRK_SUPPORTED_FILE_FMT _grk_cparameters::decod_format

input file format

## deviceId

int32_t _grk_cparameters::deviceId

## display_resolution

double _grk_cparameters::display_resolution[2]

## duration

uint32_t _grk_cparameters::duration

## enableTilePartGeneration

bool _grk_cparameters::enableTilePartGeneration

Tile part generation.

## framerate

uint16_t _grk_cparameters::framerate

## image_offset_x0

uint32_t _grk_cparameters::image_offset_x0

subimage compressing: origin image offset in x direction

## image_offset_y0

uint32_t _grk_cparameters::image_offset_y0

subimage compressing: origin image offset in y direction

## infile

char _grk_cparameters::infile[GRK_PATH_LEN]

input file name

## irreversible

bool _grk_cparameters::irreversible

1 : use the irreversible DWT 9-7, 0 : use lossless compression (default)

## is_binary_comment

bool _grk_cparameters::is_binary_comment[GRK_NUM_COMMENTS_SUPPORTED]

## kernelBuildOptions

uint32_t _grk_cparameters::kernelBuildOptions

## layer_distortion

double _grk_cparameters::layer_distortion[GRK_MAX_LAYERS]

layer PSNR values

## layer_rate

double _grk_cparameters::layer_rate[GRK_MAX_LAYERS]

layers rates expressed as compression ratios.

They might be subsequently limited by the max_cs_size field

## max_comp_size

uint32_t _grk_cparameters::max_comp_size

Maximum size (in bytes) for each component.

If == 0, component size limitation is not considered

## max_cs_size

uint64_t _grk_cparameters::max_cs_size

Maximum size (in bytes) for the whole code stream.

If equal to zero, code stream size limitation is not considered If it does not comply with layer_rate, max_cs_size prevails and a warning is issued.

## mct

uint8_t _grk_cparameters::mct

MCT (multiple component transform)

## mct_data

void* _grk_cparameters::mct_data

Naive implementation of MCT restricted to a single reversible array based compressing without offset concerning all the components.

## newTilePartProgressionDivider

uint8_t _grk_cparameters::newTilePartProgressionDivider

new tile part progression divider

## num_comments

size_t _grk_cparameters::num_comments

## numgbits

uint8_t _grk_cparameters::numgbits

## numlayers

uint16_t _grk_cparameters::numlayers

number of layers

## numpocs

uint32_t _grk_cparameters::numpocs

number of progression order changes (POCs), default to 0

## numresolution

uint8_t _grk_cparameters::numresolution

number of resolutions

## numThreads

uint32_t _grk_cparameters::numThreads

## outfile

char _grk_cparameters::outfile[GRK_PATH_LEN]

output file name

## prch_init

uint32_t _grk_cparameters::prch_init[GRK_J2K_MAXRLVLS]

initial precinct height

## prcw_init

uint32_t _grk_cparameters::prcw_init[GRK_J2K_MAXRLVLS]

initial precinct width

## prog_order

GRK_PROG_ORDER _grk_cparameters::prog_order

progression order (default is LRCP)

## progression

grk_progression _grk_cparameters::progression[GRK_J2K_MAXRLVLS]

progressions

## rateControlAlgorithm

GRK_RATE_CONTROL_ALGORITHM _grk_cparameters::rateControlAlgorithm

## raw_cp

grk_raw_cparameters _grk_cparameters::raw_cp

## repeats

uint32_t _grk_cparameters::repeats

## res_spec

uint32_t _grk_cparameters::res_spec

## roi_compno

int32_t _grk_cparameters::roi_compno

region of interest: affected component in [0..3]; -1 indicates no ROI

## roi_shift

uint32_t _grk_cparameters::roi_shift

region of interest: upshift value

## rsiz

uint16_t _grk_cparameters::rsiz

RSIZ value To be used to combine GRK_PROFILE_*, GRK_EXTENSION_* and (sub)levels values.

## subsampling_dx

uint8_t _grk_cparameters::subsampling_dx

subsampling value for dx

## subsampling_dy

uint8_t _grk_cparameters::subsampling_dy

subsampling value for dy

## t_height

uint32_t _grk_cparameters::t_height

YTsiz.

## t_width

uint32_t _grk_cparameters::t_width

XTsiz.

## tile_size_on

bool _grk_cparameters::tile_size_on

size of tile: tile_size_on = false (not in argument) or = true (in argument)

## tx0

uint32_t _grk_cparameters::tx0

XTOsiz.

## ty0

uint32_t _grk_cparameters::ty0

YTOsiz.

## verbose

bool _grk_cparameters::verbose

## write_capture_resolution

bool _grk_cparameters::write_capture_resolution

## write_capture_resolution_from_file

bool _grk_cparameters::write_capture_resolution_from_file

## write_display_resolution

bool _grk_cparameters::write_display_resolution

## writePLT

bool _grk_cparameters::writePLT

## writeTLM

bool _grk_cparameters::writeTLM

The documentation for this struct was generated from the following file:

- grok.h